Codeforces Round 951 (Div. 2)

2024-06-08 14:52
文章标签 codeforces round div 951

本文主要是介绍Codeforces Round 951 (Div. 2),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

在这里插入图片描述

A - Guess the Maximum

直接暴力枚举 a i , a i + 1 a_i,a_{i+1} ai,ai+1找最小的最大值
答案即为最小的最大值-1

code:


#include<bits/stdc++.h>
#define endl '\n'
#define fast() ios::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr)
#define F first
#define S second
#define lowbit(x) ((x) & (-x))
#define _ int _T; cin >> _T; while(_T --) 
#define int long long
#define no cout << "NO" << endl
#define yes cout << "YES" << endlusing namespace std;
typedef pair<int, int> PII;
typedef pair<char,int> PCI;
const int N = 3e5 + 7;
const int mod = 998244353;
int n,m,k;
int a[N],b[N];
//PII p[N];void solve(){cin >> n;for(int i = 0;i < n;i ++) cin >> a[i];int mx = 1e18;for(int i = 0;i < n - 1;i ++){mx = min(mx,max(a[i],a[i + 1]));}cout << mx - 1 << endl;
}signed main(){fast();_solve();return 0;
} 

B - XOR Sequences

序列长度无限 所以从最低位到最高位按位枚举 答案为小于最先不同的位数的所有值 即 ( 1 < < i ) (1<<i) (1<<i) 高位总会有 ⨁ \bigoplus 后使其相等的值

code:


#include<bits/stdc++.h>
#define endl '\n'
#define fast() ios::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr)
#define F first
#define S second
#define lowbit(x) ((x) & (-x))
#define _ int _T; cin >> _T; while(_T --) 
#define int long long
#define no cout << "NO" << endl
#define yes cout << "YES" << endlusing namespace std;
typedef pair<int, int> PII;
typedef pair<char,int> PCI;
const int N = 3e5 + 7;
const int mod = 998244353;
int n,m,k;
int a[N],b[N];
//PII p[N];void solve(){cin >> n >> m;for(int i = 0;i < 32;i ++){int cnt1 = (n >> i) & 1;int cnt2 = (m >> i) & 1;if(cnt1 != cnt2){cout << ((int)1 << i) << endl;return;}}  
}signed main(){fast();_solve();return 0;
} 

C - Earning on Bets

假设每一位放的硬币数为 a i a_i ai 那么总共就会放 s u m = ∑ i = 1 n a i sum = \sum\limits_{i = 1}^n{a_i} sum=i=1nai个硬币
然后我们我们知道获胜会得到 a i ∗ k i a_i*k_i aiki金币 并且 s u m < a i ∗ k i sum < a_i*k_i sum<aiki
s u m k i sum \over k_i kisum < a i a_i ai
并且有 ∑ i = 1 n s u m k i < ∑ i = 1 n a i \sum\limits_{i = 1}^n{sum \over k_i} < \sum\limits_{i = 1}^n{a_i} i=1nkisum<i=1nai
∑ i = 1 n s u m k i < s u m \sum\limits_{i = 1}^n{sum \over k_i} < sum i=1nkisum<sum
那么有 ∑ i = 1 n 1 k i < 1 \sum\limits_{i = 1}^n{1 \over k_i} < 1 i=1nki1<1
那么我们可以令 s u m = l c m ( k 1 , k 2 , k 3 , . . . , k n ) sum = lcm(k_1,k_2,k_3,...,k_n) sum=lcm(k1,k2,k3,...,kn)
这样 s u m ∗ k i sum * k_i sumki可以不剩余并且可以 s u m k i sum \over k_i kisum的分给每个位置的 a i a_i ai
即有 ∑ i = 1 n s u m k i < s u m \sum\limits_{i = 1}^n{sum \over k_i} < sum i=1nkisum<sum 满足此式子即说明有一个解
解为每个位置分 s u m k i sum \over k_i kisum

code:


#include<bits/stdc++.h>
#define endl '\n'
#define fast() ios::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr)
#define F first
#define S second
#define lowbit(x) ((x) & (-x))
#define _ int _T; cin >> _T; while(_T --) 
#define int long long
#define no cout << "NO" << endl
#define yes cout << "YES" << endlusing namespace std;
typedef pair<int, int> PII;
typedef pair<char,int> PCI;
const int N = 3e5 + 7;
const int mod = 998244353;
int n,m,k;
int a[N],b[N];
//PII p[N];void solve(){cin >> n;int lcm = 1;for(int i = 0;i < n;i ++){cin >> a[i];lcm = (a[i] * lcm) / __gcd(a[i],lcm);}  int sum = 0;for(int i = 0;i < n;i ++) sum += lcm / a[i];if(sum >= lcm){cout << -1 << endl;return;}for(int i = 0;i < n;i ++) cout << lcm / a[i] << " ";cout << endl;
}signed main(){fast();_solve();return 0;
} 

D - Fixing a Binary String

直接从头开始遍历并且记录连续的0或1的个数
如果遍历过程中个数大于k了 那么就有两种切割情况:

  • 直接从刚大于时的位置前切开
  • 看末尾的连续序列长度是否小于k 如果小于k并且 s i = = s n s_i == s_n si==sn那就说明此处可以拼接上去 就从此序列开始位置+ (k - 末尾的连续序列长度 - 1)处切割

然后看这两种切割方式是否可以达成连续k个0或1交替出现即可
如果遍历过程中个数小于k了 :

  • 那么就在此前切割

code:


#include<bits/stdc++.h>
#define endl '\n'
#define fast() ios::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr)
#define F first
#define S second
#define lowbit(x) ((x) & (-x))
#define _ int _T; cin >> _T; while(_T --) 
#define int long long
#define no cout << "NO" << endl
#define yes cout << "YES" << endlusing namespace std;
typedef pair<int, int> PII;
typedef pair<char,int> PCI;
const int N = 3e5 + 7;
const int mod = 998244353;
int n,m,k;
int a[N],b[N];
//PII p[N];
int flag;void check(string ans){int len = 1;for(int i = 1;i < n;i ++){if(ans[i] == ans[i - 1]){len ++;if(len > k){flag = 1;break;}} else{if(len != k){flag = 1;break;}len = 1;}}    
}void solve(){cin >> n >> k;string s; cin >> s;int pos = -1,cnt = 1;int pos2 = -1;int st = 0;int mx = 1;for(int i = n - 2;i >= 0;i --){if(s[i] != s[i + 1]){break;} else{mx ++;}}for(int i = 1;i < n;i ++){if(s[i] == s[i - 1]){cnt ++;if(cnt > k){pos = i - 1;if(s[i] == s[n - 1]){if(mx >= k) pos2 = -1;else if(i - st >= k - mx) pos2 = st + k - mx - 1;}break;}} else{if(cnt != k){pos = i - 1;break;}st = i;cnt = 1;}}if(pos == -1){cout << n << endl;return;}string s1 = s.substr(0,pos + 1);string s2 = s.substr(pos + 1);reverse(s1.begin(),s1.end());string ans = s2 + s1;flag = 0;check(ans);if(!flag){cout << pos + 1 << endl;return;}if(pos2 == -1){cout << -1 << endl;return;}s1 = s.substr(0,pos2 + 1);s2 = s.substr(pos2 + 1);reverse(s1.begin(),s1.end());ans = s2 + s1;flag = 0;check(ans);if(!flag){cout << pos2 + 1 << endl;return;}cout << -1 << endl;
}signed main(){fast();_solve();return 0;
} 

这篇关于Codeforces Round 951 (Div. 2)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/1042503

相关文章

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja

CSS实现DIV三角形

本文内容收集来自网络 #triangle-up {width: 0;height: 0;border-left: 50px solid transparent;border-right: 50px solid transparent;border-bottom: 100px solid red;} #triangle-down {width: 0;height: 0;bor

创建一个大的DIV,里面的包含两个DIV是可以自由移动

创建一个大的DIV,里面的包含两个DIV是可以自由移动 <body>         <div style="position: relative; background:#DDF8CF;line-height: 50px"> <div style="text-align: center; width: 100%;padding-top: 0px;"><h3>定&nbsp;位&nbsp;

Codeforces Round 971 (Div. 4) (A~G1)

A、B题太简单,不做解释 C 对于 x y 两个方向,每一个方向至少需要 x / k 向上取整的步数,取最大值。 由于 x 方向先移动,假如 x 方向需要的步数多于 y 方向的步数,那么最后 y 方向的那一步就不需要了,答案减 1 代码 #include <iostream>#include <algorithm>#include <vector>#include <string>

CF#271 (Div. 2) D.(dp)

D. Flowers time limit per test 1.5 seconds memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/474/problem/D We s

CF #278 (Div. 2) B.(暴力枚举+推导公式+数学构造)

B. Candy Boxes time limit per test 1 second memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/488/problem/B There